## cpustat 0.01.24

=== Makefile ===
#
# Copyright (C) 2011-2015 Canonical
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
#
# Author: Colin Ian King <colin.king@canonical.com>
#

VERSION=0.01.24

CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

#
# Some useful optimisation settings for GCC
#
# -Winline \
# -fwhole-program -freciprocal-math -ffast-math \
# --param max-reload-search-insns=32768 \
# --param max-cselib-memory-locations=32768
#
BINDIR=/usr/sbin
MANDIR=/usr/share/man/man8

cpustat: cpustat.o Makefile
	$(CC) $(CPPFLAGS) $(CFLAGS)  $< -lm -o $@ $(LDFLAGS)

cpustat.o: cpustat.c Makefile

cpustat.8.gz: cpustat.8
	gzip -c $< > $@

dist:
	rm -rf cpustat-$(VERSION)
	mkdir cpustat-$(VERSION)
	cp -rp README Makefile cpustat.c cpustat.8 COPYING cpustat-$(VERSION)
	tar -zcf cpustat-$(VERSION).tar.gz cpustat-$(VERSION)
	rm -rf cpustat-$(VERSION)

clean:
	rm -f cpustat cpustat.o cpustat.8.gz
	rm -f cpustat-$(VERSION).tar.gz


install: cpustat cpustat.8.gz
	mkdir -p ${DESTDIR}${BINDIR}
	cp cpustat ${DESTDIR}${BINDIR}
	mkdir -p ${DESTDIR}${MANDIR}
	cp cpustat.8.gz ${DESTDIR}${MANDIR}

=== debian/changelog ===
cpustat (0.01.24-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: remove dist tarball on make clean
  * check if sample_delta_list_tail is null rather than the head
  * Don't initialise duration, it gets set later
  * Remove another dead assignment to sdi
  * Remove dead assignment to sdi
  * Remove dead assignment to cs

 -- Colin King <colin.king@canonical.com>  Wed, 9 Sep 2015 11:39:42 +0100

cpustat (0.01.23-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: fix section field, set to admin
  * debian/control: fix architecture; change to linux-any
  * debian/copyright: fix upstream name field

 -- Colin King <colin.king@canonical.com>  Tue, 18 Aug 2015 20:47:00 -0700

cpustat (0.01.22-1) unstable; urgency=medium

  * Prepare for inital upload to Debian: (Closes: #795914)
  * debian/copyright: update format field
  * debian/control: change email address
  * Makefile: bump version

 -- Colin King <colin.king@canonical.com>  Mon, 17 Aug 2015 15:11:38 -0700

cpustat (0.01.21-1) unstable; urgency=medium

  * Makefile: bump version
  * Update debian/compat and control to version 9 and add Homepage
  * Update manual, rewrite some sections and add an extra example
  * Add README
  * Some minor tweaks for 80 char wide tty formatting
  * Remove debian/cpustat.install, not needed now
  * Make bindir /usr/sbin
  * Update year in debian/copyright
  * Re-work debian/control description text
  * Don't scale blocked and running
  * Scale proc stats by duration
  * Scale distribution of CPU utilisation per CPU appropriately

 -- Colin King <colin.king@canonical.com>  Fri, 14 Aug 2015 19:40:00 +0100

cpustat (0.01.20-1) unstable; urgency=medium

  * Makefile: bump version
  * Remove double scaling by duration in stats

 -- Colin King <colin.king@canonical.com>  Fri, 14 Aug 2015 13:43:33 +0100

cpustat (0.01.19-1) unstable; urgency=medium

  * Makefile: bump version
  * Minor fixes that got introduced over the past week:
  * Make proc_stat scanning more efficient and do only when -x selected
  * Add Author in comment block
  * Makefile: Add copyright and comment on some useful gcc options
  * Init cpu_info_t fields
  * Nullify sdl->sample_delta_item_list, re-arrange some fields
  * Add LIKELY/UNLIKELY optimisation hints
  * Optimise cpu_info_find, don't alloc comm field anymore
  * Use malloc instead of calloc since we fill all the fields in the structs
  * Pass cpu_stat info into cpu_stat_add and replace calloc with malloc
  * Hash on comm and pid rather than making up an ident
  * Optimise parsing in cpus_online
  * Avoid call to sample_add if not required
  * Fix theoretical overflow
  * Correct toctou on cmdline
  * Avoid division by zero on total_ticks
  * Ensure end of buffer is null terminated
  * Remove redundant d > 9 check, will never happen with a modulo 10
  * Fix fd leak
  * Fix % output in banner now that we are not using printf
  * Use optimised string to integer parsing as this occurs frequently
  * Save ~2000 cycles per banner dump
  * Optimise load_average to not use sscanf(), saves ~200K cycles
  * Optimise /proc/$pid/stat parsing, saves ~500K cycles per iteration
  * Make pid hash table relatively large prime
  * Re-use old PIDs infos
  * More optimisations
  * Add some minor speed optimisations, saves a few million cycles
  * Add new tasks rate stat in -x option output
  * Add width specifier in scanf
  * Remove proc_stat alloca()
  * Remove alloca in cpu_distribution
  * Reduce scope of buffer
  * Make pid_info_hash_free static
  * Add more comments
  * Fix accuracy in ticks when accumulating ticks with interrupted select
  * Use uint64_t as clock ticks type
  * Break out of proc_stat parsing when we have all the necessary data
  * double_to_timeval: pass tv rather than return it.
  * Add more comments
  * Enhance distribution stats and expand manual
  * Pass nr_ticks rather than re-compute it
  * Minor correction in manual
  * Add caching to proc cmdline
  * Don't add to sorted list cpu_stats with zero total time
  * Reduce scope of buffer
  * Add more comments
  * Add alloca failure checks
  * Correct division in cpu freq computation
  * Add some /proc/stat stats with -x option
  * Correct the life time of the process stats in grand total
  * Add State (S), Processor and Time used stats
  * Minor re-formatting
  * Add -x option (extra CPU info)
  * Add -D distribution option
  * Add -g option

 -- Colin King <colin.king@canonical.com>  Fri, 14 Aug 2015 13:11:35 +0100

cpustat (0.01.18-1) unstable; urgency=medium

  * Makefile: bump version
  * Fix memleak in cpu info cmdline
  * Forgot to add cpu info onto the hash table
  * Append sdls to the sample delta list rather than prepend them
  * Fix missing cpu list length increment
  * Make source 80 chars wide tty friendly
  * Re-arrange fields in structs for better alignment

 -- Colin King <colin.king@canonical.com>  Thu, 6 Aug 2015 23:41:11 +0100

cpustat (0.01.17-1) unstable; urgency=medium

  * Makefile: bump version
  * Add -O2 for default optimisation level
  * free cmdline if it is not the same as comm field
  * Add some GCC optimisation hints
  * Reduce hash table size, reduced cache stalls
  * Re-use old cpu_stat_t via a free list
  * Re-organise lists, remove extra level of indirection
  * Use a hash on cpu_info's to do far faster lookup
  * Use a more efficient hash

 -- Colin King <colin.king@canonical.com>  Tue, 30 Jun 2015 22:07:00 +0100

cpustat (0.01.16-1) unstable; urgency=medium

  * Makefile: bump version
  * Remove SIGILL, SIGABRT sighandling

 -- Colin King <colin.king@canonical.com>  Mon, 18 May 2015 00:18:00 +0100

cpustat (0.01.15-1) unstable; urgency=medium

  * Makefile: bump version
  * Add copyright and a few more refs to manual
  * Minor tidyup and ensuring duration is sharp
  * Add a timestamp -S option
  * Handle time deltas more exactly, this is required if cpustat gets suspended
  * Fix whence so that we get real wall clock time in whence field


## cpustat 0.01.25

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.01.24
+VERSION=0.01.25
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.01.25-1ubuntu0) xenial; urgency=medium

  * Only add pid info to hash table if it is new (LP: #1631050)
    - fixes double free error on exit

 -- Colin King <colin.king@canonical.com>  Thu, 6 Oct 2016 17:17:18 +0100

cpustat (0.01.25-1) unstable; urgency=medium

  * Makefile: bump version
  * Fix division by zero error when total_ticks is zero (LP: #1506156)

 -- Colin King <colin.king@canonical.com>  Wed, 14 Oct 2015 18:40:00 +0100

=== debian/watch ===
version=3
http://kernel.ubuntu.com/~cking/tarballs/cpustat/cpustat-(.+).tar.gz

## cpustat 0.01.26

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2011-2015 Canonical
+# Copyright (C) 2011-2016 Canonical
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.01.25
+VERSION=0.01.26
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.01.26-1) unstable; urgency=medium

  * Makefile: bump version
  * Update date in manual
  * debian/control: update standards version to 3.9.7
  * Fix spelling mistake in manual, onlt -> only
  * Update copyright year to 2016

 -- Colin King <colin.king@canonical.com>  Thu, 28 Apr 2016 10:10:10 +0100

=== debian/control ===
Source: cpustat
Section: admin
Priority: optional
Maintainer: Colin King <colin.king@canonical.com>
Standards-Version: 3.9.7
Build-Depends: debhelper (>= 9)
Homepage: http://kernel.ubuntu.com/~cking/cpustat

Package: cpustat
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: periodic cpu utilization statistics
 cpustat periodically reports the current CPU utilization of running tasks
 and can optionally report per CPU and per task utilization statistics at
 the end of a run.  cpustat has been designed and optimized to use a minimal
 amount of CPU cycles to monitor a system hence it is a light weight
 alternative to traditional process monitoring tools such as top.

## cpustat 0.01.27

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.01.26
+VERSION=0.01.27
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.01.27-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: update standards version to 3.9.8

 -- Colin King <colin.king@canonical.com>  Thu, 5 May 2016 13:49:16 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9)
 Homepage: http://kernel.ubuntu.com/~cking/cpustat

## cpustat 0.01.29

=== Makefile ===
--- 
+++ 
@@ -18,10 +18,19 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.01.27
+VERSION=0.01.29
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
 
+#
+# Pedantic flags
+#
+ifeq ($(PEDANTIC),1)
+CFLAGS += -Wabi -Wcast-qual -Wfloat-equal -Wmissing-declarations \
+	-Wmissing-format-attribute -Wno-long-long -Wpacked \
+	-Wredundant-decls -Wshadow -Wno-missing-field-initializers \
+	-Wno-missing-braces -Wno-sign-compare -Wno-multichar
+endif
 #
 # Some useful optimisation settings for GCC
 #
@@ -44,7 +53,7 @@
 dist:
 	rm -rf cpustat-$(VERSION)
 	mkdir cpustat-$(VERSION)
-	cp -rp README Makefile cpustat.c cpustat.8 COPYING cpustat-$(VERSION)
+	cp -rp README Makefile cpustat.c cpustat.8 COPYING mascot snapcraft cpustat-$(VERSION)
 	tar -zcf cpustat-$(VERSION).tar.gz cpustat-$(VERSION)
 	rm -rf cpustat-$(VERSION)

=== debian/changelog ===
cpustat (0.01.29-1) unstable; urgency=medium

  * Makefile: bump version
  * Fix variable shadowing on variable duration
  * Use FLOAT_CMP helper macro to perform slop on float compares
  * Constify variables in sort compare helper
  * Makefile: add PEDANTIC build flags

 -- Colin King <colin.king@canonical.com>  Wed, 2 Nov 2016 14:24:41 -0600

cpustat (0.01.28-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: add mascot and snapcraft directories to make dist rule
  * cpustat: only add pid info to hash table if it is new (LP: #1631050)
  * snapcraft: Makefile: fix removal errors of snap files
  * snapcraft: Makefile: add auto versioning
  * snapcraft.yaml: add build-packages
  * Add snapcraft Makefile
  * Add cpustat pngs
  * mascot: small resize to ensure it scales perfectly to 128x128
  * Add cpustat mascot

 -- Colin King <colin.king@canonical.com>  Thu, 6 Oct 2016 17:30:00 +0100

## cpustat 0.02.00

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.01.29
+VERSION=0.02.00
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
 
@@ -43,7 +43,7 @@
 MANDIR=/usr/share/man/man8
 
 cpustat: cpustat.o Makefile
-	$(CC) $(CPPFLAGS) $(CFLAGS)  $< -lm -o $@ $(LDFLAGS)
+	$(CC) $(CPPFLAGS) $(CFLAGS)  $< -lm -lncurses -o $@ $(LDFLAGS)
 
 cpustat.o: cpustat.c Makefile

=== debian/changelog ===
cpustat (0.02.00-1) unstable; urgency=medium

  * Makefile: bump version to 0.02.00
  * Debian control: add libncurses5-dev to Build-Depends
  * Fix timestamp output
  * Retry select sleep if we have some pending sleep time
  * Minor reworking to handle optimal refreshing and size refetching
  * Default winsize if we can't fetch it, and fetch size on setup
  * Handle display modes using display_function_t handlers
  * Add -X top like mode
  * Ensure large integer constant is ULL

 -- Colin King <colin.king@canonical.com>  Sun, 4 Dec 2016 20:55:21 +0000

## cpustat 0.02.01

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.00
+VERSION=0.02.01
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.01-1) unstable; urgency=medium

  * Makefile: bump version
  * Remove df_putc, we don't use it now
  * Minor cleanup, add more comments
  * Remove another slow snprintf in cpu_freq_format
  * Generalise putdouble_point1 to n decimal places, rename putdec to putint
  * Remove another snprintf from proc_stat_dump
  * Add command and spacing before Freq Avg text
  * Remove another use of expensive sprintf
  * Add putuint helper and remove another overly used snprintf
  * Fix incorrect closing square bracket around kernel thread
  * Remove another snprintf and replace with more optimal code
  * Add some minor optimisations
  * Optimise printing so we don't use printf which is expensive
  * Add comments to putdec function
  * Generalise putdec function to handle any decimal sized string
  * Use inline popcount to count bits
  * Ensure in top mode we don't fall off bottom of terminal

 -- Colin King <colin.king@canonical.com>  Tue, 6 Dec 2016 12:04:42 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
 Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9)
+Build-Depends: debhelper (>= 9), libncurses5-dev
 Homepage: http://kernel.ubuntu.com/~cking/cpustat
 
 Package: cpustat

## cpustat 0.02.02

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2011-2016 Canonical
+# Copyright (C) 2011-2017 Canonical
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.01
+VERSION=0.02.02
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.02-1) unstable; urgency=medium

  * Makefile: bump version
  * Remove some redundant pointer increments
  * Update copyright year
  * Add libncursesw5-dev to snapcraft yaml
  * Don't do a resize() in SIGWINCH signal handler

 -- Colin King <colin.king@canonical.com>  Wed, 1 Mar 2017 23:28:27 +0000

## cpustat 0.02.03

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.02
+VERSION=0.02.03
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.03-1) unstable; urgency=medium

  * Makefile: bump version
  * Manual: update copyright year and manual date
  * Add variable pid size handling.
  * Voidify close/fclose calls

 -- Colin King <colin.king@canonical.com>  Sat, 15 Apr 2017 07:17:27 +0100

## cpustat 0.02.04

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2011-2017 Canonical
+# Copyright (C) 2011-2018 Canonical
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.03
+VERSION=0.02.04
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.04-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: update Standards-Version to 4.1.2
  * Remove redundant initialization of pointer 'str'
  * Use sizeof on object
  * Make array index variables size_t
  * Use SIZEOF_ARRAY on cpu_freq_scale rather than a terminator marker
  * Update copyright year

 -- Colin King <colin.king@canonical.com>  Wed, 31 Jan 2018 10:49:22 +0000

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
-Standards-Version: 3.9.8
+Standards-Version: 4.1.2
 Build-Depends: debhelper (>= 9), libncurses5-dev
 Homepage: http://kernel.ubuntu.com/~cking/cpustat

## cpustat 0.02.05

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.04
+VERSION=0.02.05
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.05-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/copyright: use secure URI
  * debian/control: remove empty line at end of file
  * debian/compat: set to 11
  * debian/control: set debhelper version >= 11
  * voidify function returns
  * constify cpu_freq_scale
  * Minor code clean ups
  * Add more constifcations to functions and arrays
  * Fix the time scaling, use base 60 where necessary
  * Fix leading zeros on time data

 -- Colin King <colin.king@canonical.com>  Thu, 14 Jun 2018 18:46:12 +0100

## cpustat 0.02.06

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.05
+VERSION=0.02.06
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
 
@@ -53,13 +53,14 @@
 dist:
 	rm -rf cpustat-$(VERSION)
 	mkdir cpustat-$(VERSION)
-	cp -rp README Makefile cpustat.c cpustat.8 COPYING mascot snapcraft cpustat-$(VERSION)
-	tar -zcf cpustat-$(VERSION).tar.gz cpustat-$(VERSION)
+	cp -rp README Makefile cpustat.c cpustat.8 COPYING mascot \
+		.travis.yml snap cpustat-$(VERSION)
+	tar -Jcf cpustat-$(VERSION).tar.xz cpustat-$(VERSION)
 	rm -rf cpustat-$(VERSION)
 
 clean:
 	rm -f cpustat cpustat.o cpustat.8.gz
-	rm -f cpustat-$(VERSION).tar.gz
+	rm -f cpustat-$(VERSION).tar.xz
 
 
 install: cpustat cpustat.8.gz

=== debian/changelog ===
cpustat (0.02.06-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: add .travis.yml to make dist rule
  * debian/watch: change .gz to .xz
  * Makefile: remove .xz tarball on make dist rule
  * Makefile: generate .xz tarball and not .gz as it compresses better
  * Makefile: rename snapcraft to snap in make dist rule
  * Don't show CPU frequency if it cannot be read
  * Rename snapcraft directory to snap
  * Add travis yaml file

 -- Colin King <colin.king@canonical.com>  Thu, 6 Sep 2018 08:42:45 +0100

## cpustat 0.02.07

=== Makefile ===
--- 
+++ 
@@ -18,9 +18,9 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.06
+VERSION=0.02.07
 
-CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
+CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -g
 
 #
 # Pedantic flags

=== snap/Makefile ===
VERSION=$(shell git tag | tail -1 | cut -c2-)
COMMITS=$(shell git log --oneline | wc -l)
SHA=$(shell git log -1 --oneline | cut -d' ' -f1)
DATE=$(shell date +'%Y%m%d')
V=$(VERSION)-$(DATE)-$(COMMITS)-$(SHA)

all: get_icon set_version
	snapcraft

set_version:
	cat snapcraft.yaml | sed 's/version: .*/version: $(V)/' > snapcraft-tmp.yaml
	mv snapcraft-tmp.yaml snapcraft.yaml

get_icon: 
	@if [ ! -e setup/gui/icon.svg ]; \
	then \
		echo copying icon.svg; \
		mkdir -p setup/gui; \
		cp ../mascot/cpustat.svg setup/gui/icon.svg; \
	fi;

clean:
	rm -rf setup *.snap
	snapcraft clean
	cat snapcraft.yaml | sed 's/version: .*/version: 0/' > snapcraft-tmp.yaml
	mv snapcraft-tmp.yaml snapcraft.yaml

=== debian/changelog ===
cpustat (0.02.07-1) unstable; urgency=medium

  * Makefile: bump version
  * Re-arrange fields in structs to pack data more efficiently

 -- Colin King <colin.king@canonical.com>  Wed, 24 Oct 2018 09:22:22 +0100

## cpustat 0.02.08

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2011-2018 Canonical
+# Copyright (C) 2011-2019 Canonical
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.07
+VERSION=0.02.08
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -g

=== debian/changelog ===
cpustat (0.02.08-1) unstable; urgency=medium

  * Makefile: bump version
  * Fix strncpy string size
  * Reduce scope of variable i
  * Update copyright year

 -- Colin King <colin.king@canonical.com>  Tue, 9 Jul 2019 11:51:12 +0100

## cpustat 0.02.09

=== Makefile ===
--- 
+++ 
@@ -18,9 +18,9 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.08
+VERSION=0.02.09
 
-CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -g
+CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
 
 #
 # Pedantic flags

=== debian/changelog ===
cpustat (0.02.09-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: remove -g flag
  * Avoid division by zero if total is zero

 -- Colin King <colin.king@canonical.com>  Tue, 30 Jul 2019 13:18:23 +0100

## cpustat 0.02.10

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2011-2019 Canonical
+# Copyright (C) 2011-2020 Canonical
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.09
+VERSION=0.02.10
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
 
@@ -41,6 +41,7 @@
 #
 BINDIR=/usr/sbin
 MANDIR=/usr/share/man/man8
+BASHDIR=/usr/share/bash-completion/completions
 
 cpustat: cpustat.o Makefile
 	$(CC) $(CPPFLAGS) $(CFLAGS)  $< -lm -lncurses -o $@ $(LDFLAGS)
@@ -54,7 +55,7 @@
 	rm -rf cpustat-$(VERSION)
 	mkdir cpustat-$(VERSION)
 	cp -rp README Makefile cpustat.c cpustat.8 COPYING mascot \
-		.travis.yml snap cpustat-$(VERSION)
+		.travis.yml snap bash-completion cpustat-$(VERSION)
 	tar -Jcf cpustat-$(VERSION).tar.xz cpustat-$(VERSION)
 	rm -rf cpustat-$(VERSION)
 
@@ -68,3 +69,5 @@
 	cp cpustat ${DESTDIR}${BINDIR}
 	mkdir -p ${DESTDIR}${MANDIR}
 	cp cpustat.8.gz ${DESTDIR}${MANDIR}
+	mkdir -p ${DESTDIR}${BASHDIR}
+	cp bash-completion/cpustat ${DESTDIR}${BASHDIR}

=== debian/changelog ===
cpustat (0.02.10-1) unstable; urgency=medium

  * Makefile: bump version
  * Makefile: add bash-completion to make dist rule
  * Add bash completion script
  * Update copyright to 2020
  * snapcraft: add automatic versioning

 -- Colin King <colin.king@canonical.com>  Sun, 23 Feb 2020 23:25:22 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
 Standards-Version: 4.1.2
-Build-Depends: debhelper (>= 9), libncurses5-dev
+Build-Depends: debhelper (>= 11), libncurses5-dev
 Homepage: http://kernel.ubuntu.com/~cking/cpustat
 
 Package: cpustat
@@ -15,4 +15,3 @@
  the end of a run.  cpustat has been designed and optimized to use a minimal
  amount of CPU cycles to monitor a system hence it is a light weight
  alternative to traditional process monitoring tools such as top.
-

=== debian/watch ===
version=3
http://kernel.ubuntu.com/~cking/tarballs/cpustat/cpustat-(.+).tar.xz

## cpustat 0.02.11

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.10
+VERSION=0.02.11
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.11-1) unstable; urgency=medium

  * Makefile: bump version
  * Debian/control: add Rules-Requires-Root: no
  * debian/control: update to compat 13
  * cpustat: zero ws struct to clear static analysis warnings

 -- Colin King <colin.king@canonical.com>  Sat, 4 Jul 2020 10:33:32 +0100

## cpustat 0.02.12

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.11
+VERSION=0.02.12
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.12-1) unstable; urgency=medium

  * Makefile: bump version
  * cpustat: fix truncated output, allow CPU % stats > 100%
  * snapcraft: replace version-script with an override

 -- Colin King <colin.king@canonical.com>  Thu, 10 Sep 2020 13:14:15 +0100

## cpustat 0.02.13

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.12
+VERSION=0.02.13
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.13-1) unstable; urgency=medium

  * Makefile: bump version
  * cpustat: handle case where comm field contains ) and spaces

 -- Colin King <colin.king@canonical.com>  Sat, 7 Nov 2020 16:51:22 +0000

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,12 @@
 Source: cpustat
+Rules-Requires-Root: no
 Section: admin
 Priority: optional
 Maintainer: Colin King <colin.king@canonical.com>
 Standards-Version: 4.1.2
-Build-Depends: debhelper (>= 11), libncurses5-dev
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (=13),
+               libncurses5-dev
 Homepage: http://kernel.ubuntu.com/~cking/cpustat
 
 Package: cpustat

## cpustat 0.02.14

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 #
-# Copyright (C) 2011-2020 Canonical
+# Copyright (C) 2011-2021 Canonical
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.13
+VERSION=0.02.14
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.14-1) unstable; urgency=medium

  * Makefile: bump version
  * Remove update of sz as the result is never read
  * debian/copyright: update copyright to 2021
  * Update copyright year to 2021

 -- Colin King <colin.king@canonical.com>  Thu, 29 Apr 2021 08:38:34 +0100

## cpustat 0.02.15

=== Makefile ===
--- 
+++ 
@@ -18,7 +18,7 @@
 # Author: Colin Ian King <colin.king@canonical.com>
 #
 
-VERSION=0.02.14
+VERSION=0.02.15
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.15-1) unstable; urgency=medium

  * Makefile: bump version
  * snapcraft: add build architectures
  * Set endptr to null to clear up pedantic static analysis

 -- Colin King <colin.king@canonical.com>  Fri, 25 Jun 2021 13:22:12 +0100

## cpustat 0.02.16

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,6 @@
 #
 # Copyright (C) 2011-2021 Canonical
+# Copyright (C) 2021 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -15,10 +16,10 @@
 # along with this program; if not, write to the Free Software
 # Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.
 #
-# Author: Colin Ian King <colin.king@canonical.com>
+# Author: Colin Ian King <colin.i.king@gmail.com>
 #
 
-VERSION=0.02.15
+VERSION=0.02.16
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
 
@@ -54,7 +55,7 @@
 dist:
 	rm -rf cpustat-$(VERSION)
 	mkdir cpustat-$(VERSION)
-	cp -rp README Makefile cpustat.c cpustat.8 COPYING mascot \
+	cp -rp README.md Makefile cpustat.c cpustat.8 COPYING mascot \
 		.travis.yml snap bash-completion cpustat-$(VERSION)
 	tar -Jcf cpustat-$(VERSION).tar.xz cpustat-$(VERSION)
 	rm -rf cpustat-$(VERSION)

=== debian/changelog ===
cpustat (0.02.16-1) unstable; urgency=medium

  * Makefile, rename email address, add copyright, bump version
  * cpustat.c: Update copyright and email address
  * Makefile: rename README to README.md in make dist rule
  * REAME.md: Add markdown
  * Rename README to README.md
  * manual: update date, author email and copyright
  * debian/copyright: Update copyright and git URL
  * debian/control: update author email address and project URL
  * snap: update to core20

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 15 Nov 2021 19:17:15 +0000

=== debian/control ===
--- 
+++ 
@@ -2,12 +2,12 @@
 Rules-Requires-Root: no
 Section: admin
 Priority: optional
-Maintainer: Colin King <colin.king@canonical.com>
-Standards-Version: 4.1.2
+Maintainer: Colin Ian King <colin.i.king@gmail.com>
+Standards-Version: 4.5.1
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libncurses5-dev
-Homepage: http://kernel.ubuntu.com/~cking/cpustat
+Homepage: https://github.com/ColinIanKing/cpustat
 
 Package: cpustat
 Architecture: linux-any

## cpustat 0.02.17

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 # Author: Colin Ian King <colin.i.king@gmail.com>
 #
 
-VERSION=0.02.16
+VERSION=0.02.17
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.17-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: update to standards version 4.6.0
  * Don't emit newline in quiet mode, e.g.  cpustat  -Dqg  1 10

 -- Colin Ian King <colin.i.king@gmail.com>  Sat, 11 Dec 2021 09:02:12 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libncurses5-dev

## cpustat 0.02.18

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2011-2021 Canonical
-# Copyright (C) 2021 Colin Ian King
+# Copyright (C) 2021-2022 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -19,7 +19,7 @@
 # Author: Colin Ian King <colin.i.king@gmail.com>
 #
 
-VERSION=0.02.17
+VERSION=0.02.18
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.18-1) unstable; urgency=medium

  * Makefile: bump version
  * Debian/control: update standards version to 4.6.1
  * Update copyright year
  * Manual: Fix spelling mistake "paricular" -> "particular"
  * Fix spelling mistake: threashold -> threashold
  * cpustat: ensure pointer info is NULL

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 30 Nov 2022 15:10:11 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libncurses5-dev

## cpustat 0.02.19

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2011-2021 Canonical
-# Copyright (C) 2021-2022 Colin Ian King
+# Copyright (C) 2021-2023 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -19,7 +19,7 @@
 # Author: Colin Ian King <colin.i.king@gmail.com>
 #
 
-VERSION=0.02.18
+VERSION=0.02.19
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2

=== debian/changelog ===
cpustat (0.02.19-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: use libncurses-dev instead of deprecated libncurses5-dev
  * Update copyright year

 -- Colin Ian King <colin.i.king@gmail.com>  Tue, 7 Feb 2023 14:13:12 +0000

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Standards-Version: 4.6.1
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
-               libncurses5-dev
+               libncurses-dev
 Homepage: https://github.com/ColinIanKing/cpustat
 
 Package: cpustat

## cpustat 0.02.20

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2011-2021 Canonical
-# Copyright (C) 2021-2023 Colin Ian King
+# Copyright (C) 2021-2024 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -19,9 +19,9 @@
 # Author: Colin Ian King <colin.i.king@gmail.com>
 #
 
-VERSION=0.02.19
+VERSION=0.02.20
 
-CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2
+CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -g
 
 #
 # Pedantic flags

=== debian/changelog ===
cpustat (0.02.20-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/rules: add missing hardening settings
  * debian/control: update standards version
  * Update copyright year to 2024
  * Check for array bounds limit while parsing pid length string
  * Remove snapcraft

 -- Colin Ian King <colin.i.king@gmail.com>  Mon, 8 Jan 2024 13:53:37 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libncurses-dev

## cpustat 0.02.21

=== Makefile ===
--- 
+++ 
@@ -19,7 +19,7 @@
 # Author: Colin Ian King <colin.i.king@gmail.com>
 #
 
-VERSION=0.02.20
+VERSION=0.02.21
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -g

=== debian/changelog ===
cpustat (0.02.21-1) unstable; urgency=medium

  * Makefile: bump version
  * debian/control: update Standards-Version to 4.7.0
  * cpustat: cater for incorrect ordering of cpus being parsed, fix potential overflow

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 17 Jul 2024 14:58:23 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libncurses-dev

## cpustat 0.03.00

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,6 @@
 #
 # Copyright (C) 2011-2021 Canonical
-# Copyright (C) 2021-2024 Colin Ian King
+# Copyright (C) 2021-2025 Colin Ian King
 #
 # This program is free software; you can redistribute it and/or
 # modify it under the terms of the GNU General Public License
@@ -19,7 +19,7 @@
 # Author: Colin Ian King <colin.i.king@gmail.com>
 #
 
-VERSION=0.02.21
+VERSION=0.03.00
 
 CFLAGS += -Wall -Wextra -DVERSION='"$(VERSION)"' -O2 -g

=== debian/changelog ===
cpustat (0.03.00-1) unstable; urgency=medium

  * Makefile: bump version to 0.03.00
  * debian/control: update Standards-Version to 4.7.1.1
  * cpustat: handle negative return from sysconf(_SC_NPROCESSORS_ONLN)
  * Update copyright year

 -- Colin Ian King <colin.i.king@gmail.com>  Wed, 26 Feb 2025 12:45:11 +0000

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Maintainer: Colin Ian King <colin.i.king@gmail.com>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.1.1
 Build-Depends: debhelper (>= 13),
                debhelper-compat (=13),
                libncurses-dev

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

override_dh_auto_build:
	$(shell dpkg-buildflags --export=sh); dh_auto_build

%:
	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?V?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
             https://github.com/ColinIanKing/cpustat/tags \
             (?:.*?/)?V?(\d[\d.]*)\.tar\.gz debian uupdate
